open Mislib
open RequestDescriptor
module Unix = UnixLabels

exception IoFailure;;

(* will be started with establish_server, method handleConnection  *)
class examinerTransaction (sock:Mislib.tcpSocket) =
  object
	val mutable port = 9999;
	val availables = Queue.create();
	val waitingRequests = Queue.create();
	val queueMutex = Mutex.create();
	val queueCv = Condition.create();
	method setPort p = port <- p;
	method handleConnection (infd:in_channel) (outfd:out_channel) =
	  (* get an event to handle *)
	  Mutex.lock queueMutex;
	  while Queue.length waitingRequests == 0 do
      Condition.wait queueCv queueMutex
	  done;
    let (req:RequestDescriptor.requestDescriptor) = Queue.take waitingRequests in
      Mutex.unlock queueMutex;
      if sock#puts req#gethost = false then raise IoFailure;
      if sock#puts req#getrid = false then raise IoFailure;
    (*fall through to end thread*)
  end
;;
