let port = ref 9999;;
let tracelevel = ref 0;;
let logname = ref "wserverlog";;
let tracename = ref "wtracelog";;
let blpage = ref "BlacklistPage";;
let ckpage = ref "CheckingsitePage";;
let headerlog = ref "wsHeaderLog";;
let responselog = ref "wsResponseLog";;
let htmlBlockerRoot = ref "/usr/local/apache2/blocker/htdocs";;
let htmlExaminerRoot = ref "/usr/local/apache2/htdocs";;
let redirectHeader = ref "redirect.header";;
let examinerHtml = ref "examiner.html";;
let examiningHtml = ref "examining.html";;
let examinerServerName = ref "http://amethyst.cql.com/";;
let cgiport = ref 12000;;


let usage = "Usage: argtest.ml -port <port>";;

let argi name dest desc = (name, Arg.Int(fun x -> dest := x), desc);;

let argsd name dest desc = (name, Arg.String(fun x -> dest := x), desc);;

let main () =
Arg.parse [
  argi "-port" port "port number";
  argi "-tracelevel" tracelevel  "tracing level";
  argsd "-logname" logname "log file name";
  argsd "-tracename" tracename "tracefile name";
  argsd "-blpage" blpage "blacklist HTML template";
  argsd "-ckpage" ckpage "checking site template";
  argsd "-headerlog" headerlog "header log file name";
  argsd "-responselog" responselog "response log file name";
  argsd "-htmlBlockerRoot" htmlBlockerRoot "block htdocs";
  argsd "-htmlExaminerRoot" htmlExaminerRoot "htdocs directory for examiner";
  argsd "-redirectHeader" redirectHeader "template for returning redirect header";
  argsd "-examinerHtml" examinerHtml "template for examiner display";
  argsd "-examiningHtml" examiningHtml "template for client examining display";
  argsd "-examinerServerName" examinerServerName "server for examiner displays";
  argi "-cgiport" cgiport "port for examiner contacts";
] (fun y -> Printf.printf "%s\n" y)  usage;
print_int(!port);
print_newline();
print_string(!blpage);
print_newline();
;;

main () ;;
