module Unix = UnixLabels;;
module Stringmap = Map.Make (String);;
module Stringset = Set.Make (String);;


module Associations =
	struct
		let filename = ref "associations.list";;
		let setFilename lstr = filename := lstr;;

		let map = ref Stringmap.empty;;
		let set = ref Stringset.empty;;

		let readline chan =
			try
				let li = input_line chan in
				let fs = Str.split (Str.regexp "\t") li in
					map := Stringmap.add (List.nth fs 0) (List.nth fs 1) !map;
					set := Stringset.add (List.nth fs 0) !set;
			with End_of_file ->
				print_endline "association input complete";;

		let initialize =
			let chan = open_in_gen [Open_rdonly;Open_text;] 0 !filename in
				readline chan;;

		let association lstr = Stringmap.find lstr !map;;
	end;;
