open Mis

let checkline fname str lineno =
	let linenostr = (string_of_int lineno) in
	let lnum2str = Str.matched_group 2 str in
	let lnumber2 = (int_of_string lnum2str) in
		if lineno <> lnumber2
		then
			begin
				let strippedstr = Str.replace_first (Str.regexp "^[ \t]*") "" str in
					prerr_endline ("File \"" ^ fname ^ "\", line " ^ linenostr ^ ":");
					prerr_endline ("line number mismatch, is " ^ lnum2str ^ ", should be " ^ linenostr ^ ", line=\n" ^ strippedstr);
				exit 2
			end;;

let rec oneline fname inch reli reliN reliExN lineno =
	let str = input_line inch in
		if Str.string_match reli str 0
		then
			begin
				prerr_endline "__LINE__ found";
				exit 1
			end
		else if Str.string_match reliN str 0 then checkline fname str lineno
		else if Str.string_match reliExN str 0 then checkline fname str lineno;

		oneline fname inch reli reliN reliExN (lineno+1);;


let fname = Mis.arg 1 in
let inch = open_in fname in
let reline = Str.regexp "^.*__LINE__.*$" in
let relineN = Str.regexp "^[ \t]*\\(Logger.show[ \t]*[0-9][ \t]*\\\"[^\\\"]+\\\"\\)[ \t]*\\([1-9][0-9]*\\)\\(.*\\)$" in
let relineExN = Str.regexp "^[ \t]*\\(Logger.showex[ \t]*\\\"[^\\\"]+\\\"\\)[ \t]*\\([1-9][0-9]*\\)\\(.*\\)$" in
	try
		oneline fname inch reline relineN relineExN 1
	with x ->
		match x with
				End_of_file -> prerr_endline "successful completion..."
			| xx -> prerr_endline ("Exception: " ^ (Printexc.to_string xx));;
