module Unix = UnixLabels
open Mis
open Examiner
open Connection
open Urldb
open Associations
open Logger
open Clientinfo

module Client =
  struct

		exception EndOfConnection;;

		let redirectHeader = new Mis.misString;;
		let setRedirectHeader hdr = redirectHeader#setstr hdr;;

    type arg_type = Clientinfo.clientInfo;;

		let arg = new Clientinfo.clientInfo;;

    let argfrom lrq lblocksz lrole llchan lhchan reheader =
			let cinfo = new Clientinfo.clientInfo in
				cinfo#set lrq lblocksz lrole llchan lhchan reheader;;

		let reAt = Str.regexp "@";;

		let returnRedirect rheader host clientconn =
			let lrheader = Str.replace_first reAt host rheader#getimage in
				ignore(clientconn#writeToSource lrheader);;

		let manageConnection fdac cinfo udb (clientConn:Connection.connection) =
			(* open connection to host *)
			Logger.show 2 "client.ml" 34 "top of manageConnection";
			let hrequest = clientConn#getRequestHeader in
			let lhost = hrequest#host in
			let lport = hrequest#port in
			let serverconn = new Mis.tcpSocket lhost lport in
				clientConn#setServerfd serverconn;
				clientConn#writeBlock;

				try
					while true do
						clientConn#transferBlock Mis.ClientToServer;
						clientConn#transferBlock Mis.ServerToClient;
					done

				with x ->
					match x with
							EndOfConnection ->ignore ()
						| xx -> Logger.showex "client.ml" 57 xx "Unexpected exception in transfer loop";;
				
		let handleConnection ((cfd:Unix.file_descr),(csaddr:Unix.sockaddr),(cinfo:Clientinfo.clientInfo)) =
			Logger.show 3 "client.ml" 54 "handleConnection";
			try
				begin
					let fdac = new Mis.fdAndChannel in
						fdac#setfromfd cfd;
						let clientConn = new Connection.connection fdac cinfo in
						let udb = new Urldb.urldb fdac#id in
							Logger.show 3 "client.ml" 61 "calling readHeader...";
							clientConn#readHeader Mis.ClientToServer;
							Logger.show 3 "client.ml" 63 "back from readHeader...";
							let lhost = clientConn#getRequestHeader#host in
								Logger.show 3 "client.ml" 65 ("lhost="^lhost);
								let testhost = Associations.association lhost in
									match (udb#status testhost) with
											Urldb.Black ->
												Logger.show 3 "client.ml" 69 ("black site="^testhost);
												returnRedirect cinfo#redirectHeader ("blacklist.html#" ^ testhost) clientConn;
										| Urldb.White ->
												Logger.show 3 "client.ml" 72 ("white site="^testhost);
												manageConnection fdac cinfo udb clientConn
										| Urldb.Unknown ->
												Logger.show 3 "client.ml" 75 ("unknown site="^testhost);
												ignore ();
				end
			with x ->
				Logger.showex "client.ml" 79 x "exception caught in Client.handleConnection";
				raise x;
end;;
