(*open Printf;;*)
module Unix = UnixLabels
open Mis

module Logger =
struct
	(* chan is for normal trace logging *)
	let chan = new Mis.fdAndChannel;;
	let setchan fd = chan#set (Mis.FileDescr fd);;
	let setchanfromoutchan ch = chan#setfromoutchan ch;;

	(* exchan is for exception trace logging  *)
	let exchan = new Mis.fdAndChannel;;
	let setexchan fd = exchan#set fd;;
	let setexchanfromoutchan ch = exchan#setfromoutchan ch;;

	(* datachan is for logging of payload data such as packets  *)
	let datachan = new Mis.fdAndChannel;;
	let setdatachan fd = datachan#set fd;;

  let tracelevel = ref 0;;
  let setTraceLevel tl = tracelevel := tl;;
  let mu = Mutex.create ();;

  let intro fi li =
    let tm = (Unix.localtime(Unix.time())) in
			Printf.sprintf "%02d\t%02d:%02d:%04d:%02d:%02d:%02d\t%s@%04d\t"
				(Thread.id(Thread.self()))
				tm.Unix.tm_mday
				(tm.Unix.tm_mon+1)
				tm.Unix.tm_year
				(tm.Unix.tm_hour+1)
				(tm.Unix.tm_min+1)
				(tm.Unix.tm_sec+1)
				fi
				li;;

  let showgen tl fi li msg cl (chan:Mis.fdAndChannel) =
    Mutex.lock mu;
    if cl=false || tl < !tracelevel
    then
			begin
				let lintro = intro fi li in
				let ochan = chan#asOutchan in
					Printf.fprintf ochan "%s%s\n" lintro msg;
					flush ochan;
			end;
		Mutex.unlock mu;;

  let show tl fi li msg =
    showgen tl fi li msg true chan;;
  let showex fi li ex msg =
    showgen 0 fi li (msg ^ ":" ^ Printexc.to_string ex) false exchan;;
end;;
