open Logger

let rec oneline inch outch reli reliN reliExN fname lineno =
	let str = input_line inch in
		if Str.string_match reli str 0 then

			output_string outch ((Str.matched_group 1 str) ^ "\"" ^ fname ^ "\" " ^ (string_of_int lineno) ^ (Str.matched_group 3 str) ^ "\n")

		else if Str.string_match reliN str 0 then
			output_string outch ((Str.matched_group 1 str) ^ " " ^ (string_of_int lineno) ^ (Str.matched_group 3 str) ^ "\n")
		else if Str.string_match reliExN str 0 then
			output_string outch ((Str.matched_group 1 str) ^ " " ^ (string_of_int lineno) ^ (Str.matched_group 3 str) ^ "\n")
		else
			output_string outch (str ^ "\n");

		oneline inch outch reli reliN reliExN fname (lineno+1)
;;

Logger.setchanfromoutchan stdout;
Logger.setexchanfromoutchan stderr;

let fname = (Array.get Sys.argv 1) in
let backupname = (fname ^ ".backup") in
	Sys.command ("mv " ^ fname ^ " " ^ backupname);
	let inch = open_in backupname in
	let outch = open_out fname in
		try
			let reline = Str.regexp "^\\(.*\\)\\(__FILE__[ \t]+__LINE__\\)\\(.*\\)$" in
			let relineN = Str.regexp "^\\([ \t]*Logger.show[ \t]*[0-9][ \t]*\\\"[^\\\"]+\\\"\\)[ \t]*\\([1-9][0-9]*\\)\\(.*\\)$" in
			let relineExN = Str.regexp "^\\([ \t]*Logger.showex[ \t]*\\\"[^\\\"]+\\\"\\)[ \t]*\\([1-9][0-9]*\\)\\(.*\\)$" in
				oneline inch outch reline relineN relineExN (Array.get Sys.argv 1) 1;

with x ->
	match x with
			End_of_file -> prerr_endline "successful completion..."
		| xx -> Logger.showex "setFileAndLine.ml" 32 xx "exception in main."
