open Mis
open Logger

module type FUNC_TYPE =
  sig
    type arg_type
    val handleConnection : Unix.file_descr * Unix.sockaddr * arg_type -> unit
    val arg : arg_type
  end;;

module Tcpserver =
  functor (Func: FUNC_TYPE) ->
    struct
      class tcpServer ip port =
        object(self)
        val mcv = new Mis.mucv;
        val maxconn = 100;
        val saddr = (Unix.ADDR_INET(Unix.inet_addr_of_string(ip),port));
        val sock = Unix.socket Unix.PF_INET Unix.SOCK_STREAM 0;

				method run =
					try
						Unix.bind sock saddr;
						Unix.listen sock maxconn;
						while true do
							let (cfd,csaddr) = Unix.accept sock in
								Thread.create Func.handleConnection (cfd,csaddr,Func.arg)
						done
					with x ->
						Logger.showex "tcpserver.ml" 30 x "Exception in run method.";
      end;;

			let loop (ip,port) =
				let tserve = new tcpServer ip port in
					tserve#run;;

			let start ip port =
				Thread.create loop (ip,port);;
end;;
